package ru.ifmo.ga.ca.dct;

import ru.ifmo.ga.fx.Fitness;
import ru.ifmo.ga.fx.Point;
import ru.ifmo.ga.ca.tournament.Tournament;
import ru.ifmo.ga.ca.dct.CAPoint;

public class CAFitness implements Fitness {

    private static final int FIELD_SIZE = 149;
    private static final int DEFAULT_TEST_CASES = 5000;
    private static final int STEPS = 2 * FIELD_SIZE;

    private final Tournament trn = new Tournament();

    private int testCases = DEFAULT_TEST_CASES;

    public int getTestCases() {
        return (int) trn.getSettings().getRuns();
    }

    public void setTestCases(int testCases) {
        trn.getSettings().setRuns(testCases);
    }

    public CAFitness() {
        trn.getSettings().setSize(FIELD_SIZE);
        trn.getSettings().setRuns(testCases);
        trn.getSettings().setSteps(STEPS);
    }

    public double calculate(Point p) {
        CAPoint caPoint = (CAPoint) p;
        trn.getRules().clear();
        trn.getRules().add(caPoint.getRule());
        return trn.play().getResults().get(0).getValue();
    }

}
