package ru.ifmo.ga.ca.dct.modules;

import ru.ifmo.ga.ca.dct.CAModule;
import ru.ifmo.ga.ca.dct.CAPoint;
import ru.ifmo.ga.ca.KnownCARepository;
import ru.ifmo.ga.ca.Rule;
import ru.ifmo.ga.fx.UploadResult;

import java.rmi.RemoteException;
import java.lang.reflect.Field;
import java.io.IOException;

public class BestRulesProviderModule extends CAModule {

    public BestRulesProviderModule() throws IOException, IllegalAccessException {
        Field[] fields = KnownCARepository.class.getFields();
        for (Field field : fields) {
            String v = (String)field.get(null);
            System.out.println(add(v) + " " + field.getName());
        }
        repository.save();
    }

    private UploadResult add(String rule) throws RemoteException {
        Rule r = new Rule();
        r.setRadius(3);
        r.parseRule(rule);
        CAPoint ca = new CAPoint();
        ca.getMetadata().setClientName(getClass().getSimpleName());
        ca.setRule(r);

        return repository.uploadPoint(ca);
    }

    public static void main(String[] args) throws IOException, IllegalAccessException {
        new BestRulesProviderModule();
    }

}
