package ru.ifmo.ga.ca.dct.modules;

import ru.ifmo.ga.ca.dct.CAModule;
import ru.ifmo.ga.ca.dct.CAPoint;
import ru.ifmo.ga.ca.dct.CAFitness;
import ru.ifmo.ga.fx.Point;

import java.util.TreeSet;
import java.util.ArrayList;
import java.util.Collections;

public class FitnessModule extends CAModule {
    private static final int MIN_TESTCASES = 100000;
    private CAFitness fitness = new CAFitness();

    public FitnessModule() throws Exception{
        fitness.setTestCases(MIN_TESTCASES);
        System.out.println(repository.getSize());
        ArrayList<Point> points = new ArrayList<Point>(repository.getPoints());
        Collections.sort(points);
        Collections.reverse(points);
        for (Point p : points) {
            CAPoint ca = (CAPoint) p;
            if (ca.getMetadata().getTestCases() < MIN_TESTCASES) {
                System.out.println("[old] " + ca.getMetadata().getValue() + " on " + ca.getMetadata().getTestCases() + " tests.");
                CAPoint caNew = ca.clone();
                caNew.getMetadata().setTestCases(MIN_TESTCASES);
                caNew.getMetadata().setValue(fitness.calculate(caNew));
                System.out.println("[new] " + caNew.getMetadata().getValue() + " on " + caNew.getMetadata().getTestCases() + " tests.");
                repository.replacePoint(ca, caNew);
                repository.save();
            } else {
                System.out.println("ok");
            }
        }
        repository.save();
    }

    public static void main(String[] args) throws Exception{
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
        new FitnessModule();
    }
}
