package ru.ifmo.ga.ca.dct.modules;

import ru.ifmo.ga.ca.dct.CAPoint;
import ru.ifmo.ga.ca.dct.CARepository;
import ru.ifmo.ga.fx.Point;

import java.io.*;

public class RepConverter {
    private PointsSet points = new PointsSet();
    int maxSize;

    private void loadPoint(CAPoint p, DataInputStream dis) throws IOException {
        p.getRule().setRadius(dis.readInt());
        for (int i = 0; i < p.getRule().getLength(); i++) {
            p.getRule().setBit(i, dis.readBoolean());
        }

        // pointMetadata
        p.getMetadata().setValue(dis.readDouble());
    }

    public void load() throws IOException {
        DataInputStream dis = new DataInputStream(new FileInputStream(CARepository.DEFAULT_CA_REPOSITORY_NAME));
        maxSize = dis.readInt();
        int size = dis.readInt();
        points.clear();
        for (int i = 0; i < size; i++) {
            CAPoint caPoint = new CAPoint();
            loadPoint(caPoint, dis);
            points.add(caPoint);
            System.out.println(caPoint.getMetadata().getTestCases() + " " + caPoint.getMetadata().getValue());
        }
        dis.close();

        System.out.println("ok! size: " + size);
    }

    public void save() throws IOException {
        DataOutputStream dos = new DataOutputStream(new FileOutputStream("newrep"));
        dos.writeInt(maxSize);
        dos.writeInt(points.size());
        for (Point p : points) {
            ((CAPoint)p).save(dos);
        }
        dos.close();
        System.out.println("ok!");
    }

    public static void main(String[] args) throws Exception {
        RepConverter rc = new RepConverter();
        rc.load();
        rc.save();
    }

}
