package ru.ifmo.ga.ca.gui;

import ru.ifmo.ga.ca.SimpleCA;

import javax.swing.*;
import java.awt.*;

/**
 * User: Yuri D. Bedny
 * Date: Apr 8, 2006
 * Time: 1:31:50 PM
 */

public class CAFrame extends JFrame {
    private final CAControlPanel caControlPanel = new CAControlPanel();
    private final CAField caField = new CAField();

    public CAFrame(SimpleCA ca) throws HeadlessException {
        caField.getModel().setCa(ca);
        setTitle("Cellular automaton (" + ca.getRule().getInfo() + ")");
//        BoxLayout lm = new BoxLayout(getContentPane(), BoxLayout.Y_AXIS);
//        setLayout(lm);
        getContentPane().add(caField);
//        getContentPane().add(caControlPanel);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        pack();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension windowSize = getSize();
        setLocation((screenSize.width  - windowSize.width)  / 2, (screenSize.height - windowSize.height) / 2);
        setVisible(true);
    }
}
