package ru.ifmo.ga.ca.tournament;

import ru.ifmo.ga.ca.Rule;

import java.util.ArrayList;

/**
 * User: Yuri D. Bedny
 * Date: Apr 2, 2006
 * Time: 3:06:39 PM
 */

public class Tournament {
// todo: martix (i, j) - automaton i won againts configuration j

    private final Settings settings = new Settings();
    private final ArrayList<Rule> rules  = new ArrayList<Rule>();

    public Settings getSettings() {
        return settings;
    }

    public ArrayList<Rule> getRules() {
        return rules;
    }

    public Results play() {

        // Generated configurations
        ArrayList<ICContext> ics = new ArrayList<ICContext>();

        // Rememeber start time for statistics
        long startTime = System.currentTimeMillis();

        // Construct CAs
        ArrayList<CAContext> cas = new ArrayList<CAContext>(rules.size());
        for (Rule rule : rules) {
            cas.add(new CAContext(rule, settings));
        }

        // Init randomizer
        settings.getRandomizer().init();
        
        // Start tournament
        for (long run = 0; run < settings.getRuns(); run++) {
            ICContext ic = new ICContext(settings.getRandomizer().random());
            if (ic.getCfg() == null) {//no more cfg exists
                break;
            }

            ics.add(ic);

            for (CAContext ca : cas) {
                if (!ca.play(ic)) {
                    ic.getWin().add(ca);
                } else {
                    ic.getLost().add(ca);
                }
            }
        }

        return new Results(cas, ics, settings, startTime);
    }

}
