package ru.ifmo.ga.fx.desire;

import ru.ifmo.ga.fx.Point;
import ru.ifmo.ga.fx.Repository;
import ru.ifmo.ga.fx.stat.Divergence;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.TreeSet;

public class MostDifferentPointInDeltaDesire implements DownloadDesire {
    private final Point p;
    private final double neg;
    private final double pos;
    private final String clientName;

    public MostDifferentPointInDeltaDesire (String clientName, Point p, double neg, double pos) {
        this.clientName = clientName;
        this.p = p;
        this.neg = neg;
        this.pos = pos;
    }

    public String getClientName() {
        return clientName;
    }

    public Point downloadPoint(Repository rep) throws RemoteException {
        if (p.getMetadata().getValue() == 0) {
            p.getMetadata().setValue(rep.getFitness().calculate(p));
        }
        Divergence div = rep.getDivergence();
        Point result = null;
        double max = -1;
        for (Point point : rep.getPoints()) {
            if (point.getMetadata().getValue() - p.getMetadata().getValue() > -neg &&
                point.getMetadata().getValue() - p.getMetadata().getValue() < pos) {
                double divergence = div.getDivergence(point, p);
                if (divergence > max) {
                    max = divergence;
                    result = point;
                }
            }
        }
        return result;
    }

    public ArrayList<Point> downloadPoints(Repository rep) throws RemoteException {
        return null;
    }

}
