package ru.ifmo.ga.ca.tournament;

import junit.framework.TestCase;
import ru.ifmo.ga.ca.tournament.Tournament;
import ru.ifmo.ga.ca.tournament.Results;
import ru.ifmo.ga.ca.tournament.Result;
import ru.ifmo.ga.ca.Rule;
import ru.ifmo.ga.ca.KnownCARepository;

import java.util.ArrayList;
import java.util.Collections;

/**
 * User: Yuri D. Bedny
 * Date: Apr 10, 2006
 * Time: 8:59:03 PM
 */

public class TournamentTest extends TestCase {
    public void test() throws Exception {

        Rule r1 = new Rule();
        r1.setRadius(3);
        r1.parseRule(KnownCARepository.JP_2);

        Rule r2 = new Rule();
        r2.setRadius(3);
        r2.parseRule(KnownCARepository.GKL);

        Tournament t = new Tournament();
        t.getSettings().setRuns(10000);
        t.getSettings().setSteps(300);
        t.getSettings().setSize(149);

        t.getRules().add(r1);
        t.getRules().add(r2);

        Results r = t.play();
        assertEquals(10000, r.getIcCtxs().size());

        ArrayList<Result> res = r.getResults();
        assertEquals(2, res.size());

        assertEquals(r1, res.get(0).getRule());
        assertEquals(r2, res.get(1).getRule());

        assertEquals(0.86, res.get(0).getValue(), 0.05);
        assertEquals(0.816, res.get(1).getValue(), 0.05);

        Collections.sort(res);
        assertEquals(res.get(0).getRule(), r2);
        assertEquals(res.get(1).getRule(), r1);
    }
}
